<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>book-list-app documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">book-list-app documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content injectable">
                   <div class="content-data">







<ol class="breadcrumb">
  <li>Injectables</li>
  <li>BookService</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/services/book.service.ts</code>
        </p>

            <p class="comment">
                <h3>Description</h3>
            </p>
            <p class="comment">
                <p>Clase con los servicios del Api Rest</p>

            </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#_toastSuccess">_toastSuccess</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#addBook">addBook</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#deleteBook">deleteBook</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#getBooks">getBooks</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#getBooksFromCart">getBooksFromCart</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#removeBooksFromCart">removeBooksFromCart</a>
                            </li>
                            <li>
                                    <span class="modifier">Public</span>
                                <a href="#updateAmountBook">updateAmountBook</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(http: <a href="https://angular.io/api/common/http/HttpClient" target="_blank">HttpClient</a>)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="15" class="link-to-prism">src/app/services/book.service.ts:15</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div class="io-description"><p>Clase con los servicios del Api Rest</p>
</div>
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>http</td>
                                                  
                                                        <td>
                                                                        <code><a href="https://angular.io/api/common/http/HttpClient" target="_blank" >HttpClient</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
    <h3 id="methods">
        Methods
    </h3>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="_toastSuccess"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Private</span>
                            _toastSuccess
                        </b>
                        <a href="#_toastSuccess"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>_toastSuccess(book: <a href="../interfaces/Book.html">Book</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="127"
                            class="link-to-prism">src/app/services/book.service.ts:127</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>servicio para obtener libros </p>
</div>

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                    <td>Description</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>book</td>
                                    <td>
                                                <code><a href="../interfaces/Book.html" target="_self" >Book</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                    <td>
                                        <p>libro</p>

                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        <p>Observable con la respuesta del servicio</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="addBook"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Public</span>
                            addBook
                        </b>
                        <a href="#addBook"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>addBook(book: <a href="../interfaces/Book.html">Book</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="76"
                            class="link-to-prism">src/app/services/book.service.ts:76</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>servicio para agregar libros </p>
</div>

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>book</td>
                                    <td>
                                                <code><a href="../interfaces/Book.html" target="_self" >Book</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                    </div>
                    <div class="io-description">
                        <p>Observable con la respuesta del servicio</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="deleteBook"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Public</span>
                            deleteBook
                        </b>
                        <a href="#deleteBook"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>deleteBook(book: <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank">string</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="92"
                            class="link-to-prism">src/app/services/book.service.ts:92</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>servicio para eliminar libros </p>
</div>

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                    <td>Description</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>book</td>
                                    <td>
                                                <code><a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/string" target="_blank" >string</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                    <td>
                                        <p>string id del book</p>

                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                    </div>
                    <div class="io-description">
                        <p>Observable con la respuesta del servicio</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getBooks"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Public</span>
                            getBooks
                        </b>
                        <a href="#getBooks"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>getBooks()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="29"
                            class="link-to-prism">src/app/services/book.service.ts:29</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>servicio para obtener libros </p>
</div>

                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="../interfaces/ResponseInterface.html" target="_self" >Observable&lt;ResponseInterface&gt;</a></code>

                    </div>
                    <div class="io-description">
                        <p>Observable con la respuesta del servicio</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="getBooksFromCart"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Public</span>
                            getBooksFromCart
                        </b>
                        <a href="#getBooksFromCart"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>getBooksFromCart()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="58"
                            class="link-to-prism">src/app/services/book.service.ts:58</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>servicio para obtener libros </p>
</div>

                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="../interfaces/Book.html" target="_self" >Book[]</a></code>

                    </div>
                    <div class="io-description">
                        <p>Books[]: Observable con la respuesta del servicio</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="removeBooksFromCart"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Public</span>
                            removeBooksFromCart
                        </b>
                        <a href="#removeBooksFromCart"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>removeBooksFromCart()</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="69"
                            class="link-to-prism">src/app/services/book.service.ts:69</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-description"><p>servicio para obtener libros </p>
</div>

                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                    </div>
                    <div class="io-description">
                        <p>Observable con la respuesta del servicio</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
    <table class="table table-sm table-bordered">
        <tbody>
            <tr>
                <td class="col-md-4">
                    <a name="updateAmountBook"></a>
                    <span class="name">
                        <b>
                            <span class="modifier">Public</span>
                            updateAmountBook
                        </b>
                        <a href="#updateAmountBook"><span class="icon ion-ios-link"></span></a>
                    </span>
                </td>
            </tr>
            <tr>
                <td class="col-md-4">
                    <span class="modifier-icon icon ion-ios-reset"></span>
                    <code>updateAmountBook(book: <a href="../interfaces/Book.html">Book</a>)</code>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">
                    <div class="io-line">Defined in <a href="" data-line="108"
                            class="link-to-prism">src/app/services/book.service.ts:108</a></div>
                </td>
            </tr>


            <tr>
                <td class="col-md-4">

                    <div class="io-description">
                        <b>Parameters :</b>
                        <table class="params">
                            <thead>
                                <tr>
                                    <td>Name</td>
                                    <td>Type</td>
                                    <td>Optional</td>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td>book</td>
                                    <td>
                                                <code><a href="../interfaces/Book.html" target="_self" >Book</a></code>
                                    </td>

                                    <td>
                                        No
                                    </td>


                                </tr>
                            </tbody>
                        </table>
                    </div>
                    <div>
                    </div>
                    <div class="io-description">
                        <b>Returns : </b>        <code><a href="../interfaces/Book.html" target="_self" >Book[]</a></code>

                    </div>
                    <div class="io-description">
                        <p>Observable con la respuesta del servicio</p>

                    </div>
                </td>
            </tr>
        </tbody>
    </table>
</section>

    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Injectable } from &#x27;@angular/core&#x27;;
import { HttpClient, HttpHeaders } from &#x27;@angular/common/http&#x27;;
import { Observable } from &#x27;rxjs&#x27;;
import { Book, ResponseInterface, ResponseAddI } from &#x27;../models/book.model&#x27;;
import { environment } from &#x27;../../environments/environment.prod&#x27;;
import swal from &#x27;sweetalert2&#x27;;
/**
 * Clase con los servicios del Api Rest
 * 
 */
@Injectable({
providedIn:&quot;root&quot;

})
export class BookService {
/**
 * Clase con los servicios del Api Rest
 * @constructor httclient
 */
  constructor(
    private readonly http: HttpClient
  ) { }


/**
 * servicio para obtener libros 
 * @returns Observable con la respuesta del servicio
 */
  public getBooks(): Observable&lt;ResponseInterface&gt; {
    const url: string &#x3D; environment.API_REST_URL;
    const httpOptions &#x3D; {
        headers: new HttpHeaders({
        uuid: &#x27;889898989&#x27;
      })
    };
    const Toast &#x3D; swal.mixin({
      toast: true,
      position: &#x27;bottom-end&#x27;,
      showConfirmButton: false,
      timer: 2000,
      didOpen: (toast) &#x3D;&gt; {
        toast.addEventListener(&#x27;mouseenter&#x27;, swal.stopTimer);
        toast.addEventListener(&#x27;mouseleave&#x27;, swal.resumeTimer);
      }
    });

    Toast.fire({
      icon: &#x27;success&#x27;,
      title:&#x27; libros disponibles&#x27;
    });
    console.info(&quot;get books&quot;);
    return this.http.get&lt;ResponseInterface&gt;(url,httpOptions);
  }
/**
 * servicio para obtener libros 
 * @returns Books[]: Observable con la respuesta del servicio
 */
  public getBooksFromCart(): Book[] {
    let listBook: Book[] &#x3D; JSON.parse(localStorage.getItem(&#x27;listCartBook&#x27;));
    if (listBook &#x3D;&#x3D;&#x3D; null) {
      listBook &#x3D; [];
    }
    return listBook;
  }
/**
 * servicio para obtener libros 
 * @returns Observable con la respuesta del servicio
 */
  public removeBooksFromCart(): void {
    localStorage.setItem(&#x27;listCartBook&#x27;, null);
  }
/**
 * servicio para agregar libros 
 * @returns Observable con la respuesta del servicio
 */
  public addBook(book: Book) {
    const url: string &#x3D; environment.API_REST_URL;
    const httpOptions &#x3D; {
        headers: new HttpHeaders({
        uuid: &#x27;123456&#x27;
      })
    };
    console.info(&quot;add books&quot;);
    return this.http.post&lt;ResponseAddI&gt;(url,book,httpOptions);
  }

/**
 * servicio para eliminar libros 
 * @param book string id del book
 * @returns Observable con la respuesta del servicio
 */
  public deleteBook(book: string) {
    const url: string &#x3D; environment.API_REST_URL+&quot;/&quot;+book;
    
    const httpOptions &#x3D; {
        headers: new HttpHeaders({
        uuid: &#x27;123456&#x27;
      })
    };
    console.info(&quot;add books&quot;);
    return this.http.delete&lt;ResponseAddI&gt;(url,httpOptions);
  }
/**
 * @todo servicio para actualizar libros 
 * sin implentantar
 * @returns Observable con la respuesta del servicio
 */
  public updateAmountBook(book: Book): Book[] {
    const listBookCart &#x3D; this.getBooksFromCart();
    const index &#x3D; listBookCart.findIndex((item: Book) &#x3D;&gt; {
      return book.id &#x3D;&#x3D;&#x3D; item.id;
    });
    if (index !&#x3D;&#x3D; -1) {
      listBookCart[index].amount &#x3D; book.amount;
      if (book.amount &#x3D;&#x3D;&#x3D; 0) {
        listBookCart.splice(index, 1);
      }
    }
    localStorage.setItem(&#x27;listCartBook&#x27;, JSON.stringify(listBookCart));
    return listBookCart;
  }
/**
 * servicio para obtener libros 
 * @param book libro
 * @returns Observable con la respuesta del servicio
 */
  private _toastSuccess(book: Book) {
    const Toast &#x3D; swal.mixin({
      toast: true,
      position: &#x27;bottom-end&#x27;,
      showConfirmButton: false,
      timer: 2000,
      didOpen: (toast) &#x3D;&gt; {
        toast.addEventListener(&#x27;mouseenter&#x27;, swal.stopTimer);
        toast.addEventListener(&#x27;mouseleave&#x27;, swal.resumeTimer);
      }
    });
    Toast.fire({
      icon: &#x27;success&#x27;,
      title: book.name + &#x27; added to cart&#x27;
    });
  }
}
</code></pre>
    </div>

</div>







                   




                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'injectable';
            var COMPODOC_CURRENT_PAGE_URL = 'BookService.html';
            var MAX_SEARCH_RESULTS = 15;
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
